=== debian/changelog ===
ros-noetic-dynamic-graph (4.4.3-2buster) buster; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Guilhem saurel <guilhem.saurel@laas.fr>  Wed, 07 Sep 2022 12:29:00 -0000
