=== debian/control ===
Source: ros-noetic-dynamic-graph
Section: misc
Priority: optional
Maintainer: Guilhem saurel <guilhem.saurel@laas.fr>
Build-Depends: debhelper (>= 9.0.0), cmake, doxygen, git, graphviz, libboost-all-dev, libeigen3-dev
Homepage: http://github.com/stack-of-tasks/dynamic-graph
Standards-Version: 3.9.2

Package: ros-noetic-dynamic-graph
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, graphviz, libboost-all-dev, libeigen3-dev, ros-noetic-catkin
Description: Dynamic graph library
